import pandas as pd

_plot_types = {"linear": {'param': {"value": 'linear'},
                          'relative': False,
                          'percent': False,
                          'xgrid': {"visible": True, 'axis': 'x'},
                          'ygrid': {"visible": True, 'axis': 'y'},
                          },
               "rel-linear": {'param': {"value": 'linear'}, 
                              'relative': True, 
                              'percent': False,
                              'xgrid': {"visible": True, 'axis': 'x'},
                              'ygrid': {"visible": True, 'axis': 'y'},
                              },
               "percent": {'param': {"value": 'linear'}, 
                           'relative': True, 
                           'percent': True,
                           'xgrid': {"visible": True, 'axis': 'x'},
                           'ygrid': {"visible": True, 'axis': 'y'},
                           },
               "log": {"param": {"value": 'log',},
                       'relative': False,
                       'percent': False,
                       'xgrid': {"visible": True, 'axis': 'x'},
                       'ygrid': {"visible": True, "which": 'both', 'axis': 'y'},
                       },
                
               "rel-log": {"param": {"value": 'log'},#, "base": 10}, 
                           'relative': True,
                           'percent': False,
                           'xgrid': {"visible": True, 'axis': 'x'},
                           'ygrid': {"visible": True, "which": 'both', 'axis': 'y'},
                           },
               }

_plot_lengths = {"Max": {'offset': lambda dd: dd - pd.DateOffset(years=100),
                         'mark': '-',
                         },
                 "3M": {'offset': lambda dd: dd - pd.DateOffset(months=3),
                        'mark': '-|',
                        },
                 "6M": {'offset': lambda dd: dd - pd.DateOffset(months=6),
                        'mark': '-|',
                        },
                 "1Y": {'offset': lambda dd: dd - pd.DateOffset(years=1),
                        'mark': '-',
                        },
                 "2Y": {'offset': lambda dd: dd - pd.DateOffset(years=2),
                        'mark': '-',
                        },
                 "3Y": {'offset': lambda dd: dd - pd.DateOffset(years=3),
                        'mark': '-',
                        },
                 "4Y": {'offset': lambda dd: dd - pd.DateOffset(years=4),
                        'mark': '-',
                        },
                 "5Y": {'offset': lambda dd: dd - pd.DateOffset(years=5),
                        'mark': '-',
                        },
                 "7Y": {'offset': lambda dd: dd - pd.DateOffset(years=5),
                        'mark': '-',
                        },
                 "10Y": {'offset': lambda dd: dd - pd.DateOffset(years=10),
                        'mark': '-',
                        },
                 "YTD": {'offset': lambda dd: pd.Timestamp(year=dd.year-1, month=12, day=30),
                         'mark': '-',
                         },
                 }
                